:- module(bits, [code/3, asmop/3]).

code(instr(0b000000, Flags, 0,  0,    0      )) --> cc(_),  [nop             ],                                                       flags(0, Flags).
code(instr(0b010111, Flags, CC, 0,    imm(0) )) --> cc(CC), [ret             ],                                                       flags(0, Flags).
code(instr(0b010111, Flags, CC, 0,    Src    )) --> cc(CC), [jmp, Src        ],                                                       flags(0, Flags).
code(instr(0b010111, Flags, CC, Dest, Src    )) --> cc(CC), [call, Src       ], {Src = imm(Label), atom_concat(Label, '_ret', Dest)}, flags(1, Flags).
code(instr(0b000011, Flags, CC, Dest, imm(Op))) --> cc(CC), [Mnem, Dest      ], {hubop(Op, DefFlags, Mnem)},                          flags(DefFlags, Flags).
code(instr(Op,       Flags, CC, Dest, Src    )) --> cc(CC), [Mnem, Dest, Src ], {asmop(Op, DefFlags, Mnem)},                          flags(DefFlags, Flags).

asmop(0b000000, 0, wrbyte).
asmop(0b000000, 1, rdbyte).
asmop(0b000001, 0, wrword).
asmop(0b000001, 1, rdword).
asmop(0b000010, 0, wrlong).
asmop(0b000010, 1, rdlong).
asmop(0b000011, 0, hubop).
asmop(0b001000, 1, ror).
asmop(0b001001, 1, rol).
asmop(0b001010, 1, shr).
asmop(0b001011, 1, shl).
asmop(0b001100, 1, rcr).
asmop(0b001101, 1, rcl).
asmop(0b001110, 1, sar).
asmop(0b001111, 1, rev).
asmop(0b010000, 1, mins).
asmop(0b010001, 1, maxs).
asmop(0b010010, 1, min).
asmop(0b010011, 1, max).
asmop(0b010100, 1, movs).
asmop(0b010101, 1, movd).
asmop(0b010110, 1, movi).
asmop(0b010111, 1, jmpret).
asmop(0b011000, 0, test).
asmop(0b011001, 0, testn).
asmop(0b011000, 1, and).
asmop(0b011001, 1, andn).
asmop(0b011010, 1, or).
asmop(0b011011, 1, xor).
asmop(0b011100, 1, muxc).
asmop(0b011101, 1, muxnc).
asmop(0b011110, 1, muxz).
asmop(0b011111, 1, muxnz).
asmop(0b100000, 1, add).
asmop(0b100001, 1, sub).
asmop(0b100001, 0, cmp).
asmop(0b100010, 1, addabs).
asmop(0b100011, 1, subabs).
asmop(0b100100, 1, sumc).
asmop(0b100101, 1, sumnc).
asmop(0b100110, 1, sumz).
asmop(0b100111, 1, sumnz).
asmop(0b101000, 1, mov).
asmop(0b101001, 1, neg).
asmop(0b101010, 1, abs).
asmop(0b101011, 1, absneg).
asmop(0b101100, 1, negc).
asmop(0b101101, 1, negnc).
asmop(0b101110, 1, negz).
asmop(0b101111, 1, negnz).
asmop(0b110000, 0, cmps).
asmop(0b110001, 0, cmpsx).
asmop(0b110010, 1, addx).
asmop(0b110011, 1, subx).
asmop(0b110011, 0, cmpx).
asmop(0b110100, 1, adds).
asmop(0b110101, 1, subs).
asmop(0b110110, 1, addsx).
asmop(0b110111, 1, subsx).
asmop(0b111000, 1, cmpsub).
asmop(0b111001, 1, djnz).
asmop(0b111010, 0, tjnz).
asmop(0b111011, 0, tjz).
asmop(0b111100, 0, waitpeq).
asmop(0b111101, 0, waitpne).
asmop(0b111110, 1, waitcnt).
asmop(0b111111, 0, waitvid).

hubop(0b000, 0, clkset).
hubop(0b001, 1, cogid).
hubop(0b010, 0, coginit).
hubop(0b011, 0, cogstop).
hubop(0b100, 1, locknew).
hubop(0b101, 0, lockret).
hubop(0b110, 0, lockset).
hubop(0b111, 0, lockclr).

cc(0b1111) --> [].
cc(0b1111) --> [if_always].
cc(0b0000) --> [if_never].
cc(0b1010) --> [if_e].
cc(0b0101) --> [if_ne].
cc(0b0001) --> [if_a].
cc(0b1100) --> [if_b].
cc(0b0011) --> [if_ae].
cc(0b1110) --> [if_be].
cc(0b1100) --> [if_c].
cc(0b0011) --> [if_nc].
cc(0b1010) --> [if_z].
cc(0b0101) --> [if_nz].
cc(0b1001) --> [if_c_eq_z].
cc(0b0110) --> [if_c_ne_z].
cc(0b1000) --> [if_c_and_z].
cc(0b0100) --> [if_c_and_nz].
cc(0b0010) --> [if_nc_and_z].
cc(0b0001) --> [if_nc_and_nz].
cc(0b1110) --> [if_c_or_z].
cc(0b1101) --> [if_c_or_nz].
cc(0b1011) --> [if_nc_or_z].
cc(0b0111) --> [if_nc_or_nz].
cc(0b1001) --> [if_z_eq_c].
cc(0b0110) --> [if_z_ne_c].
cc(0b1000) --> [if_z_and_c].
cc(0b0010) --> [if_z_and_nc].
cc(0b0100) --> [if_nz_and_c].
cc(0b0001) --> [if_nz_and_nc].
cc(0b1110) --> [if_z_or_c].
cc(0b1011) --> [if_z_or_nc].
cc(0b1101) --> [if_nz_or_c].
cc(0b0111) --> [if_nz_or_nc].

flags(Flags, Flags) --> [].
flags(DefFlags, Flags) --> [nr], flags(DefFlags, MoreFlags), {Flags is MoreFlags /\ 0b110}.
flags(DefFlags, Flags) --> [wz], flags(DefFlags, MoreFlags), {Flags is MoreFlags \/ 0b100}.
flags(DefFlags, Flags) --> [wc], flags(DefFlags, MoreFlags), {Flags is MoreFlags \/ 0b010}.
flags(DefFlags, Flags) --> [wr], flags(DefFlags, MoreFlags), {Flags is MoreFlags \/ 0b001}.
